/*
    rugby.c
    input: try, conversion, penalty, drop-goal
    output: total points
*/

#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h> /* contains functions we may need (atoi) */

bool validateEntry(int input)
{
    if (input < 0)
    {   
        printf("Entry error.\n");
        return false;
    }
    return true;
}

int main(int argc, char const *argv[])
{
    int try;
    int conversion;
    int penalty;
    int dropGoal;

    printf("Enter number of tries: ");
    scanf("%d", &try);
    if (!validateEntry(try)) 
    {
        return (1);
    }

    printf("Enter number of conversions: ");
    scanf("%d", &conversion);
    if (!validateEntry(conversion)) 
    {
        return (1);
    }

    printf("Enter number of penalties: ");
    scanf("%d", &penalty);
    if (!validateEntry(penalty)) 
    {
        return (1);
    }

    printf("Enter number of drop goals: ");
    scanf("%d", &dropGoal);
    if (!validateEntry(dropGoal)) 
    {
        return (1);
    }

    int total = 0;

    total += (try * 5);
    total += (conversion * 2);
    total += (penalty * 3);
    total += (dropGoal * 3);
    
    printf("%d\n", total);

    return (0);
}
