/*
    Labsheet: 11, Task: 2
    Date: 21/11/24
    Task: lab-11-longest-line.c
    Description: Find the longest line in paragraph.txt
*/

// include neccessary libraries
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define FILE_NAME "paragraph.txt"
#define MAX 200

// function prototypes
void findLongestLine(char *longest);

// main function
int main(int argc, char*argv[])
{
    char longest[MAX];

    findLongestLine(longest);
    // output the results
    printf("%ld\n", strlen(longest));
    printf("%s\n", longest);
    return 0;
}

// actual function implementations
void findLongestLine(char *longest)
{
    FILE *pFile = NULL;
    pFile = fopen(FILE_NAME, "r");

    // if the file could not be opened throw and error
    if (!pFile)
    {
        printf("Error opening file\n");
        exit(1);
    }

    char line[MAX];
    
    // get the initial line
    fgets(line, MAX, pFile);
    strcpy(longest, line);

    // keep getting lines until the end of the file is hit
    while (fgets(line, MAX, pFile) != NULL)
    {
        // compare lengths of the the current longest and the line we are currently on
        if (strlen(longest) < strlen(line))
        {
            // new longest found, update the longest variable
            strcpy(longest, line);
        }
    }

    // close the file
    fclose(pFile);
}