/*
    Lab 3, Task 5
    Name: lab3-duplicated-number.c
    Description: The program prints the duplicated number if any
    Input: ./lab3-duplicated-number 4 9 12 5 7 8 4 13
    Output: 4
*/

#include <stdio.h>
#include <stdlib.h>

int checkIfDuplicatedNumber(int nums[], int length, int target);

int main(int argc, char const *argv[])
{
    int length = argc;
    int nums[length];

    for (int i = 0; i < length; i++)
    {
        int duplicate = checkIfDuplicatedNumber(nums, i, atoi(argv[i]));
        if (duplicate == 1) {
            printf("%d\n", atoi(argv[i]));
            return 0;
        }
        nums[i] = atoi(argv[i]);
    }

    printf("no duplicated number\n");
    return 0;
}

// function to check if number is in the list
// returns 0 if number is not in list
// returns 1 if number is in list
int checkIfDuplicatedNumber(int nums[], int length, int target) {
    for (int i = 0; i < length; i++) {
        if (nums[i] == target) {
            return 1;
        }
    }

    return 0;
}