/*
    Task: lab3-leap-year.c
    Date: 31/10/2024
    Input: ./lab3-leap-year 2008 2020
    Output: 2008
            2012
            2016
            2020
*/

/*
To be a leap year, the year number must be divisible by four – except for end-of-century years, 
which must be divisible by 400. 
This means that the year 2000 was a leap year, although 1900 was not. 
*/

// include necessary libraries
#include <stdlib.h>
#include <stdio.h>

// function prototypes
void checkIfLeap(int year);

// main function
int main(int argc, char*argv[])
{
    int year1 = atoi(argv[1]);
    int year2 = atoi(argv[2]);

    for (int curr = year1; curr <= year2; curr++)
    {
        checkIfLeap(curr);
    }
    

    return 0;
}


// actual function implementations
void checkIfLeap(int year)
{
    if (year % 400 == 0 || year % 4 == 0 && year % 100 != 0)
    {
        printf("%d\n", year);
    }
}