/*
    Lab 3, Task 4
    Name: lab3-search-number.c
    Description: Returns the value and index of a number
    Input: ./lab3-search-number 4 9 12 5 7 8 4 13
    Output: Found 4 at 5
*/

#include <stdio.h>
#include <stdlib.h>

int searchNumber(int nums[], int length, int target) {
    for (int i = 0; i < length; i++) {
        if (nums[i] == target) {
            return i;
        }
    }

    // return -1 if not found
    return -1;
}

int main(int argc, char const *argv[])
{
    int length = argc - 1;
    int nums[length];

    int target = atoi(argv[1]);

    // start at i = 2 to skip filename + target args
    for (int i = 2; i < argc; i++) {
        // minus 2 here to ensure the index isn't messed up from above line
        nums[i - 2] = atoi(argv[i]);
    }

    int position;
    position = searchNumber(nums, length, target);

    if (position == -1) {
        printf("%d not found\n", target);
    } else {
        printf("Found %d at %d\n", target, position);
    }

    return 0;
}
