/*
    Lab 4, Task 3
    Name: lab4-matrix-diagonal-sum.c
    Input: ./lab4-matrix-diagonal-sum 3 1 2 3 4 5 6 7 8 9
    Output: 15
*/

#include <stdlib.h>
#include <stdio.h>

// function prototypes
int diagonalSum(int *matrix, int size);

int main(int argc, char *argv[])
{
    int size = atoi(argv[1]);

    // create 2d array
    int matrix[size][size];

    for (int i = 0; i < (argc - 2); i++) {
        // i / size gives us the row number
        // i mod size gives the column number
        // i + 2 here to skip first 2 args in command
        matrix[i / size][i % size] = atoi(argv[i + 2]);
    }

    // print matrix TEST CODE*
    // for (int i = 0; i < size; i++)
    // {
    //     for (int j = 0; j < size; j++)
    //     {
    //         printf("%d ", matrix[i][j]);
    //     }
    //     printf("\n");
        
    // }

    int sum = diagonalSum(*matrix, size);

    printf("%d\n", sum);   
    
    return 0;
}

// actual function implementation
int diagonalSum(int *matrix, int size) {
    int sum = 0;

    for (int i = 0; i < size; i++) {
        int *curr = NULL;
        // curr = matrix[i][i];
        // this does what the line above does but with pointers
        // i * size gets the first element of the i'th row
        curr = matrix + ((i * size) + i);
        // add value of curr to sum
        sum = sum + *curr;
    }
    return sum;
}