/*
    Lab 5, Task 1
    Name: lab5-cal-everything.c
    Input: ./lab5-cal-everything 10 2
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

// function prototypes
float executeFunction(float(*pFunc)(int, int), int x, int y);

float sum(int x, int y);
float diff(int x, int y);
float product(int x, int y);
float divide(int x, int y);
float power(int x, int y);
float naturalLog(int x, int y);

int main(int argc, char*argv[])
{
    int num1 = atoi(argv[1]);
    int num2 = atoi(argv[2]);

    // declare function pointer variable
    float (*functionPointer)(int, int) = NULL;
    float result;

    // each time set pointer to the function and then it can be called
    functionPointer = sum;
    result = executeFunction(functionPointer, num1, num2);
    printf("%.2f\n", result);

    functionPointer = diff;
    result = executeFunction(functionPointer, num1, num2);
    printf("%.2f\n", result);

    functionPointer = product;
    result = executeFunction(functionPointer, num1, num2);
    printf("%.2f\n", result);

    functionPointer = divide;
    result = executeFunction(functionPointer, num1, num2);
    printf("%.2f\n", result);

    functionPointer = power;
    result = executeFunction(functionPointer, num1, num2);
    printf("%.2f\n", result);

    functionPointer = naturalLog;
    result = executeFunction(functionPointer, num1, num2);
    printf("%.2f\n", result);

    return 0;
}

// actual function implementations
// simple maths functions
float executeFunction(float(*pFunc)(int, int), int x, int y) {
    return pFunc(x, y);
}

float sum(int x, int y) {
    return x + y;
}

float diff(int x, int y) {
    return x - y;
}

float product(int x, int y) {
    return x * y;
}

float divide(int x, int y) {
    return (float)x / y;
}

float power(int x, int y) {
    return pow(x,y);
}

float naturalLog(int x, int y) {
    return log(x) + log(y);
}