
#include <stdio.h>
#include <stdlib.h>

int isPowerOfTwo(int num) {
    // num will be a power of two if its greater than 0
    // and has exactly one bit set in its binary representation.
    if ((num > 0) && ((num & (num - 1)) == 0))
    {
        return 1;
    }
    return 0;
}

int main(int argc, char const *argv[])
{
    int num = atoi(argv[1]);

    if (isPowerOfTwo(num))
    {
        printf("Yes\n");
    } else {
        printf("No\n");
    }
    
    return 0;
}

