#include <stdio.h>

void findMax(float a[], int length, float *maxVal, int *pos);

int main(int argc, char *argv[])
{
    float maxVal = -999; // setting this to a value outside the range
    int pos = 0;
    
    float a[10] = {0, 1, 2, 4, 2432, 5, 3, 2, 4, 1};

    // sizeof(a) - gives the total amount of bytes in the array
    // we need to divide by the size of one element (sizeof(a[0])) to get the no. of elements in array
    // => sizeof(a)/sizeof(a[0]) - gives the length of the array
    
    findMax(a, sizeof(a)/sizeof(a[0]), &maxVal, &pos);
    printf("Max value is %.1f at position %d \n", maxVal, pos);
    
	return 0;
}

void findMax(float a[], int length, float *maxVal, int *pos) {
    *maxVal = a[0];
    for (int i = 1; i < length; i++)
    {
        if (a[i] > *maxVal) {
            *maxVal = a[i];
            *pos = i;
        }
    }
}