/*
circle-area.c
*/

/* Includes */

#include <stdio.h>
#include <stdlib.h> /* contains functions we may need */

#define PI 3.1415

/*
    Function: Main
    Parameters: int argc (argument count)
    char *argv[] an array of command-line arguments
    description: Takes a single argument and computes area of circle
*/

int main(int argc, char *argv[])
{
    // Variable initialisation
    int radius = 0;
    float area = 0.0;

    // all command-line arguments come in as character strings, so atoi turns them into ints

    radius = atoi(argv[1]);
    radius = radius*radius;

    area = radius*PI; /* Calculate Area of circle */

    // print to two decimal places

    printf ("%.2f\n", area);
    // printf ("%9.2f\n", area);

    

    return (0);
}