/* 
Labsheet 2, Task 1
Name: lab2-cylinder-area.c
Input: radius, height
Output: Area of cylinder
*/

#include <stdio.h>
#include <stdlib.h>

#define PI 3.1415

int main(int argc, char*argv[])
{
    if (argc == 1) {
        printf("No input given!\n");
        return 1;
    } else if (argc == 2) {
        printf("Two arguments needed!\n");
        return 1;
    }
    // we know now that there is arguments, ensure positive validation:
    int radius = atoi(argv[1]);
    int height = atoi(argv[2]);

    if (radius < 0 || height < 0) {
        printf("The radius or height cannot be negative!\n");
    }

    float area = (2 * PI * radius * height) + (2 * PI * (radius*radius));
    printf("%.2f\n", area);

    return 0;
}
