/*
    Lab 3, Task 1
    Name: lab3-calculator.c
    Description: Either multiples or divides input
    Input: ./lab3-calculator.c multiply 2 3
    Output: 6
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// Function prototypes
float multiply(float num1, float num2);
float divide(float num1, float num2);

int main(int argc, char*argv[])
{
    // take inputs from arguments
    float num1 = atof(argv[2]);
    float num2 = atof(argv[3]);


    float answer;

    if (strcmp(argv[1], "multiply") == 0) {
        answer = multiply(num1, num2);
    } else if (strcmp(argv[1], "divide") == 0) {
        // check for divide by 0 error
        if (num2 == 0) {
            printf("invalid\n");
            return 0;
        }
        answer = divide(num1, num2);
    } else {
        printf("invalid\n");
    }

    printf("%f\n", answer);

    return 0;
}

// function to multiply two nums
float multiply(float num1, float num2) {
    return num1 * num2;
}

// function to divide two nums
float divide(float num1, float num2) {
    return num1 / num2;
}