/*
    Lab 3, Task 7
    Name: lab3-find-longest-word.c
    Description: Prints the longest word
    Input: ./lab3-find-longest-word "My college is DCU"
    Output: college
*/

// include necessary libraries
#include <stdio.h>
#include <string.h>

// function prototypes
char* getLongestString(char* words[], int length);

// main function
int main(int argc, char*argv[])
{
    char* str = argv[1];
    // specify our delimeter (space in this case)
    const char s[2] = " ";
    char *token;

    char* words[50];
    
    /* get the first token */
    token = strtok(str, s);
    
    int length = 0;
    /* walk through other tokens */
    while( token != NULL ) {
        // build an array of individual words
        words[length] = token;
        
        token = strtok(NULL, s);
        length += 1;
    }

    // find the longest string in the array
    char* res = getLongestString(words, length);
    printf("%s\n", res);

    return 0;
}

// actual function implementations
char* getLongestString(char* words[], int length) {
    // default to the first one
    char* longest = words[0];
    // then check all except the first one (i=1)
    for (int i = 1; i < length; i++)
    {
        if (strlen(words[i]) > strlen(longest))
        {
            longest = words[i];
        }
    }
    return longest;
}