/*
    Lab 3, Task 6
    Name: lab3-is-sorted.c
    Input: ./lab3-is-sorted 5 1 4 2 8
    Output: 1 2 4 5 8 (on new lines)
*/

#include <stdio.h>
#include <stdlib.h>

// Function prototypes
int bubbleSort(int nums[], int length);

int main(int argc, char*argv[])
{
    // -1 here to eliminate filename in args
    int length = argc - 1;
    int nums[length];

    for (int i = 0; i < length; i++) {
        nums[i] = atoi(argv[i + 1]);
    }
    
    bubbleSort(nums, length);
    
    return 0;
}

// Actual Function definitions
int bubbleSort(int nums[], int length) {
    int sorted = 0;

    int i, j, tmp;

    // using a while loop to keep doing passes until sorted
    while (sorted != 1) {
        // will equal 1 unless a swap happens meaning the list isn't sorted yet
        sorted = 1;
        // -1 here as we use i + 1 later which will avoid issues
        for (i = 0; i < (length - 1); i++)
        {
            j = i + 1;
            if (nums[i] > nums[j]) {
                tmp = nums[i];
                nums[i] = nums[j];
                nums[j] = tmp;
                sorted = 0;
            }
        }
    }

    for (int i = 0; i < length; i++)
    {
        printf("%d\n", nums[i]);
    }

    return 0;
}
