/*
    Lab 4, Task 1
    Name: lab4-count-character.c
    Description: The program count the number of occurences of the character in the string and print the result
    Input: ./lab4-count-character a "abcxyza"
    Output: 2
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Function Prototypes
int countChar(char *string, char target);

int main(int argc, char*argv[])
{
    // index 0 here to ensure it only gets the first character in the first arg
    char target = argv[1][0];
    // give pointer to the string to be searched
    char *pChar = argv[2];

    int count = countChar(pChar, target);

    // print the result
    printf("%d\n", count);

    return 0;
}

int countChar(char *pString, char target) {
    int count = 0;
    // while strchr doesn't return NULL
    while (pString = strchr(pString, target)) {
        // increment values
        count++;
        // if this increment wasn't here it would run forever
        pString++;
    }

    return count;
}
