/*   
    Lab 4, Task 4
    Name: lab4-search-sub-string.c
    Description: The program checks if the first string contains the second string
    Input: ./lab4-search-sub-string "This is a word" "word"
    Output: 10 13 
*/

/* include relevant libraries */
#include <stdio.h>
#include <string.h>

/* function prototypes */
char* findWord(char *string, char *targetString);

/* main function */
int main(int argc, char * argv[])
{
    // get our arguments as pointers
    char *sentence = argv[1];
    char *target = argv[2];

    char *result = findWord(sentence, target);
    
    // if target is not in string exit here with code 1.
    if (!result) {
        return 1;
    }

    // subtract the difference in addresses as this will give the position of the word in the sentence
    // result will be a bigger address as the sentence pointer is at the start
    int startPos = result - sentence;
    // find the ending pointer (position) by adding the length of target onto the starting position
    int endPos = (startPos + strlen(target)) - 1;
    printf("%d %d\n", startPos, endPos);

	return 0;
}

/* actual implementation of the functions */
char* findWord(char *string, char *targetString) {
    // define the pointer as null at the start
    char *loc = NULL;

    loc = strstr(string, targetString);

    return loc;
}