/*
    Task: ex1-is-symmetric.c
    Date: 31/10/2024
    Description:
        - 
*/

// include necessary libraries
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

// function prototypes
int checkIfSym(char *str);

// main function
int main(int argc, char*argv[])
{
    char *str = argv[1];
    int res = checkIfSym(str);

    if (res == 0) {
        printf("yes\n");
    } else {
        printf("no\n");
    }

    return 0;
}

// actual function implementations
// function will return 0 if is symmetric, 1 if it isn't
int checkIfSym(char *str)
{
    int length = strlen(str);
    int half = length / 2;

    for (int i = 0; i < half; i++)
    {
        // strcmp doesn't compare characters so here, make 2 new strings
        char currChar[2] = {str[i], '\0'};
        // ensure to add the null character at end
        char currLast[2] = {str[length - i - 1], '\0'};

        // compare these two new strings
        if (strcmp(currChar, currLast) != 0)
        {
            return 1;
        }
    }
    return 0;
}